/*
 * Buch3D.java
 * Created on 9. Mai 2003, 16:40
    Autor: Tobias Lang
 */

package Aufgabe;
import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.event.*;
import java.awt.GraphicsConfiguration;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.universe.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.behaviors.keyboard.*;
import com.sun.j3d.utils.behaviors.mouse.*;
import java.awt.event.*;
import java.awt.AWTEvent;
import java.util.Enumeration;
import com.sun.j3d.utils.behaviors.picking.*;


public class Buch3D extends javax.swing.JFrame {
   BranchGroup    m_SceneGraph;  // 
   SimpleUniverse m_SimpleUniverse;
   final Point3d origin = new Point3d(0.0d,0.0d,0.0d); 
   Canvas3D m_canvas; 
   TransformGroup m_tgMouseMove;
   
   public Buch3D() {
      initFenster();
      GraphicsConfiguration config = SimpleUniverse.getPreferredConfiguration();
      m_canvas = new Canvas3D(config);
      getContentPane().add("Center",m_canvas);
        //simples Universum erschaffen
      m_SimpleUniverse = new SimpleUniverse(m_canvas);
        //die Viewing Platform auf normal stellen
      m_SimpleUniverse.getViewingPlatform().setNominalViewingTransform();
      //den Scenegraph erzeugen und hinzufgen
      m_SimpleUniverse.addBranchGraph(createSceneGraph());
   }
   private void initFenster() {
       //closing button aktivieren
       setTitle("Buch Szene WIP");
       setBounds(100,100,700,700);
       addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                System.exit(0);;
            }
        });
        getContentPane().setLayout(new BorderLayout()); 
   }   
   
    //erstellt den Scengraph
   private BranchGroup createSceneGraph() {
      m_SceneGraph = new BranchGroup();
      
        // Ansicht auf Isometrisch setzen
      Transform3D tfRotY  = new Transform3D();
      Transform3D temp    = new Transform3D();
      tfRotY.rotY(GradInBogen(0));
      temp.rotX(GradInBogen(20));
      tfRotY.mul(temp);             
      TransformGroup tg_isometrisch = new TransformGroup(tfRotY);
     
       // Tisch erzeugen
      Shader shdHolz = new Shader();
       shdHolz.setColor(40 , 40,40,Shader.DIFFUSE);
     
      Shader texHolz = new Shader();
       texHolz.setColor(216, 132,0,Shader.DIFFUSE);
       texHolz.setShine(10000.0f);
       texHolz.mitTextur("Holz.jpg");
            
        //Box mit Textur Koordinaten
      Box Tisch = new Box(1.0f,0.025f,1.0f,Box.GENERATE_NORMALS | Box.GENERATE_TEXTURE_COORDS, shdHolz.getAppearance());
        
        // Face bekommt Textur;
      Tisch.getShape(Box.TOP).setAppearance(texHolz.getAppearance());
      Tisch.getShape(Box.BOTTOM).setAppearance(texHolz.getAppearance());
      
      
      tg_isometrisch.addChild(Tisch);
      
      Bleistift stift = new Bleistift(tg_isometrisch);
      KlappBuch buch = new KlappBuch(tg_isometrisch,m_canvas,m_SimpleUniverse.getLocale());
  
      
         // ***Mouse Navigation***
         //TransformGroup erstellen und Capabilities setzen
      Transform3D tfMouseMove = new Transform3D();
      m_tgMouseMove = new TransformGroup(tfMouseMove);
      m_tgMouseMove.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
      m_tgMouseMove.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
     
      MouseTranslate myMouseTranslate = new MouseTranslate();
      myMouseTranslate.setTransformGroup(m_tgMouseMove);
      myMouseTranslate.setSchedulingBounds(new BoundingSphere(origin,1000.0d));
      
      MouseRotate myMouseRotate = new MouseRotate();
      myMouseRotate.setTransformGroup(m_tgMouseMove);
      myMouseRotate.setSchedulingBounds(new BoundingSphere(origin,1000.0d));
      
      MouseZoom myMouseZoom = new MouseZoom();
      myMouseZoom.setTransformGroup(m_tgMouseMove);
      myMouseZoom.setSchedulingBounds(new BoundingSphere(origin,1000.0d));
      
       //Hierarchie erstellen
      m_SceneGraph.addChild(myMouseZoom);
      m_SceneGraph.addChild(myMouseRotate);
      m_SceneGraph.addChild(myMouseTranslate);
     
      m_tgMouseMove.addChild(tg_isometrisch);
      m_SceneGraph.addChild(m_tgMouseMove);
      
      
      Color3f clr  = new Color3f((float)211/256,(float)230/256,(float)254/256);
      Background bg = new Background(clr);
      bg.setApplicationBounds(new BoundingSphere(new Point3d(0.0d,0.0d,0.0d),1000.0d));
      m_SceneGraph.addChild(bg);
      
      setupBeleuchtung();
      m_SceneGraph.compile();
      return m_SceneGraph;
   }
   
  
   public static double GradInBogen(int grad) {
    return ((grad/180.0d)*Math.PI);
   }
   
    //Setzt die Lichter
   private void setupBeleuchtung() {
      BoundingSphere bound = new BoundingSphere(new Point3d(0.0d,0.0d,0.0d),1000.0d);
     
     PointLight pLight = new PointLight();
     pLight.setInfluencingBounds(bound);
     pLight.setPosition(-1.5f,1.6f,0.0f);
     pLight.setColor(new Color3f(0.8f,0.2f,0.0f));    
     
   /*  Transform3D tfdummy = new Transform3D();
     tfdummy.set(new Vector3f(-1.5f, 1.6f,0.0f));    
     TransformGroup tgdummy = new TransformGroup(tfdummy);
     Box dummy = new Box(0.05f,0.05f,0.05f,Box.GENERATE_NORMALS,new Appearance());
     tgdummy.addChild(dummy);
     m_tgMouseMove.addChild(tgdummy);*/
     
     DirectionalLight lightD1 = new DirectionalLight();
     lightD1.setInfluencingBounds(bound);
     Vector3f direction = new Vector3f(-1.0f, -1.0f, -1.0f);
     direction.normalize();
     lightD1.setDirection(direction);
     lightD1.setColor(new Color3f(1.0f, 1.0f, 1.0f));
    
     m_tgMouseMove.addChild(pLight);
     m_tgMouseMove.addChild(lightD1);  
     
   }
    
   public static void main(String[] args) {
     new Buch3D().show();
   }
  
}

