/*
 * CloseBehavior.java
 *
 * Created on 10. Mai 2003, 15:26
 */

package Aufgabe;
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.GraphicsConfiguration;
import com.sun.j3d.utils.applet.MainFrame; 
import com.sun.j3d.utils.geometry.ColorCube;
import com.sun.j3d.utils.universe.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import java.awt.event.*;
import java.awt.AWTEvent;
import java.util.Enumeration;
/**
 *
 * @author  Tobias
 */
public class SchliesseBehavior extends Behavior {
    private TransformGroup  m_targetTG;
    private WakeupCriterion pairPostCondition;
    private WakeupCriterion wakeupNextFrame;
    private WakeupCriterion AWTEventCondition;
    private Transform3D     t3D = new Transform3D();
    private Matrix3d        rotMat = new Matrix3d();
    private double          buchAngle;
  
    /** Creates a new instance of CloseBehavior */
     SchliesseBehavior(TransformGroup tg, Behavior Trigger){
       m_targetTG = tg;
      AWTEventCondition = new WakeupOnBehaviorPost(Trigger, 7);
       // AWTEventCondition = new WakeupOnAWTEvent(KeyEvent.KEY_PRESSED);
       wakeupNextFrame = new WakeupOnElapsedFrames(0);
     }
    
    public void setBehaviorObjectPartner(Behavior behaviorObject){
            pairPostCondition = new WakeupOnBehaviorPost(behaviorObject, 1);
    }
    
    public void initialize(){
       this.wakeupOn(AWTEventCondition);
       buchAngle = 0.0;
    }
        
    
    public void processStimulus(Enumeration criteria){
            if (criteria.nextElement().equals(pairPostCondition)){
                this.wakeupOn(AWTEventCondition);   //Wenn ffnen fertig ist, auf Pick warten
                buchAngle = 1.6f;                   //Buch ist offen
            } else { // kann MousePick oder NextFrame sein
                if (buchAngle > 0.0){
                    buchAngle -= 0.1;
                    if (buchAngle < 0.0) buchAngle = 0.0;
                    // Transform3D bekommen
                    m_targetTG.getTransform(t3D);
                    t3D.rotY(buchAngle); //winkel setzen
                    m_targetTG.setTransform(t3D);
                    this.wakeupOn(wakeupNextFrame);
                } else { //schliessen fertig, andere Behavior benachrichtigen
                    this.wakeupOn(pairPostCondition);
                    postId(1);
                }
            }
        }
    
}
